# La separación con tres clases
# y la máquina  vectores de soporte lineal
#
import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl

viridis = mpl.cm.get_cmap('viridis')

A = np.genfromtxt( "datos.csv", delimiter=',', dtype=float )

X = A[:,0:2]
y = A[:,2]
print( X.shape )
print( y.shape )

W = np.array( [[-0.1749245,   0.23141266],
               [ 0.47621194, -0.06937743],
               [-0.18914102, -0.20400558]] )

vb = np.array( [-1.0774506,   0.13140842, -0.08604983] )

# y = ( -wx x - b) / wy
vlx = np.linspace( -10.5, 8, 10 )
vly1 = (-W[0,0] * vlx - vb[0]) / W[0,1]  
vly2 = (-W[1,0] * vlx - vb[1]) / W[1,1]  
vly3 = (-W[2,0] * vlx - vb[2]) / W[2,1]  

def d( i, vx ) :
	v = W[i] @ vx + vb[i]
	return v[0]

vv = np.zeros ( (2,1) )
vm = np.zeros ( (3,) )

def decision( va ) :
	vm[0] = d( 0, va )
	vm[1] = d( 1, va )
	vm[2] = d( 2, va )
	return np.argmax( vm )


fig, ax = plt.subplots()
ax.set_aspect( 1 )

# Create grid values first.

n = 100
xi = np.linspace(-10,  8, n)
yi = np.linspace(-10, 15, n)
vx, vy = np.meshgrid( xi, yi )

zi = np.zeros( (n,n) )
i = 0
while i < n :
	vv[1,0] = yi[i]
	j = 0
	while j < n :
		vv[0,0] = xi[j]
		zi[i,j] = decision( vv ) 
		j += 1
	i += 1

# Linearly interpolate the data (x, y) on a grid defined by (xi, yi).

ax.set_xlim( (-10,8) )
ax.set_ylim( (-10,15) )

# Para poner la escala del color:
cntr = ax.contourf(vx, vy, zi )
fig.colorbar(cntr, ax=ax)

# Para poner la escala del color:
# Los puntos
ax.scatter( X[:,0], X[:,1], c=y )

ax.plot(vlx, vly1, linewidth=2, c=viridis(0.0)  )
ax.plot(vlx, vly2, linewidth=2, c=viridis(0.5) )
ax.plot(vlx, vly3, linewidth=2, c=viridis(1.0) )

plt.show( )
