import numpy as np
# 14.02.2023

# La salida del script "maquina.py"

# Pesos para cada clase
# [1. 1. 1.]

# Las tres clases
# [0. 1. 2.]

# Los coeficientes
# https://scikit-learn.org/stable/modules/svm.html#svm-mathematical-formulation
# coef_ has the shape (n_classes * (n_classes - 1) / 2, n_features) and
#                     (3,2)
# 
# 0 vs 1 [[-0.23474325  0.23143308]
# 0 vs 2  [ 0.0649192   0.15029882]
# 1 vs 2  [ 0.13788711  0.11393033]]

# t_i alpha_i
# The shape of dual_coef_ is (n_classes-1, n_SV) with a somewhat hard to grasp layout.

# The columns correspond to the support vectors involved in any
# of the n_classes * (n_classes - 1) / 2 “one-vs-one” classifiers.

# Each support vector v has a dual coefficient in each of the n_classes - 1 classifiers
# comparing the class of v against another class. Note that some, but not all,
# of these dual coefficients, may be zero.
# The n_classes - 1 entries in each column are these dual coefficients, ordered by the opposing class.

# The shape of dual_coef_ is (n_classes-1, n_SV)
#                                  (2,  5)
# 
# Hay tres máquinas con 1, 2 y 2 vectores soporte
# a^0_01 a^0_10 a^1_10 a^0_20 a^1_20
# a^0_02 a^1_12 a^1_12 a^0_21 a^1_21

va = np.array( [[ 0.05433283, -0.05433283, -0.,         -0.,         -0.01340212],
                [ 0.01340212,  0.00362461,  0.01237186, -0.01599648, -0.        ]] )

# Los cinco vectores soportes que son:
W = np.array( [[-2.30033403,  7.054616  ],
               [ 2.02013373,  2.79507219],
               [ 2.72110762,  1.94665581],
               [-6.05756703, -4.98331661],
               [-7.14428402, -4.15994043]] )

# Los tres valores para b
#  [-1.1726594   0.08903536  0.40300953]

# 0 vs 1 [[-0.23474325  0.23143308]
# 0 vs 2  [ 0.0649192   0.15029882]
# 1 vs 2  [ 0.13788711  0.11393033]]

# Clase 1
w01 = va[0,0]*W[0]   # /np.linalg.norm( W[i] )
print( w01 )
w10 = va[0,1]*W[1]
print( w10 )
print( "1", w01+w10 )

# Clase 2 
w20 = va[0,4]*W[4]   # /np.linalg.norm( W[i] )
print( w20 )
w02 = va[1,0]*W[0]
print( w02 )
print( "2", w20+w02 )

# Clase 3
w12 = va[1,1]*W[1] + va[1,2]*W[2]
print( w12 )
w21 = va[1,3]*W[3] + va[1,4]*W[4]
print( w21 )
print( "3", w12+w21 )
